import subprocess
from time import sleep

class HallSensor():
    def __init__(self):
        pass

    def read_mT(self):
        """
        Returns the value measured by the sensor in mT
        """
        process = subprocess.Popen(['src/hallsensor/read/bin/Release/net6.0/read.exe'], stdout=subprocess.PIPE, text=True)
        line = ""
        for i in range(100):
            line = process.stdout.readline().strip()
            if (line.startswith('Field')):
                break
        return float(line.split(':')[1]) * 1000.
    
    def zeroing(self):
        """
        Zeroing the probe, should be done at 0 magnetic field
        """
        process = subprocess.Popen(['src/hallsensor/zeroing/bin/Release/net6.0/zeroing.exe'], stdout=subprocess.PIPE, text=True)
        line = ""
        for i in range(100):
            line = process.stdout.readline().strip()
            if (line.startswith('Done')):
                return True
            sleep(0.02)
        return False